require 'net/ssh'
require 'net/scp'

module Magnesium
  class SSH
    attr_accessor :host
    attr_accessor :username
    attr_accessor :pwd
    attr_accessor :local
    attr_accessor :server

    def exec_command(command)
      Net::SSH.start(@host, @username, :password => @pwd) do |ssh|
        result = ssh.exec!(command.to_s)
        return result
      end
    end

    def upload_file
      Net::SCP.start(@host, @username, :password => @pwd) do |scp|
        scp.upload!(@local,@server) do |ch, name, sent, total|
          puts "\r#{name}:#{(sent.to_f * 100 / total.to_f).to_i}%"
        end
      end
    end

    def download_file #(local,server)
      Net::SCP.start(@host, @username, :password => @pwd) do |scp|
        scp.download!(@server,@local) do |ch, name, sent, total|
          puts "\r#{name}:#{(sent.to_f * 100 / total.to_f).to_i}%"
        end
      end
    end

    def upload_folder #(local,server)
      Net::SSH.start(@host, @username, :password => @pwd) do |ssh|
        ssh.scp.upload!(@local,@server,:recursive => true)
      end
    end

    def download_folder #(local,server)
      Net::SSH.start(@host, @username, :password => @pwd) do |ssh|
        ssh.scp.download!(@local,@server,:recursive => true)
      end
    end

    def download_file_to_memory #(server)
      Net::SCP.start(@host, @username, :password => @pwd) do |scp|
        return scp.download!(@server),to_yaml
      end
    end
  end
end
